---
title: Crypto.getRandomValues()
slug: Web/API/Crypto/getRandomValues
tags:
  - API
  - Crypto
  - Cryptography
  - Encryption
  - Integers
  - Method
  - Numbes
  - Pseudorandom
  - Pseudorandom Numbers
  - Random Numbers
  - Reference
  - Web Crypto API
  - getRandomValues
---
<p>{{APIRef("Web Crypto API")}}</p>

<p>The <code><strong>Crypto.getRandomValues()</strong></code> method lets you get cryptographically strong random values. The array given as the parameter is filled with random numbers (random in its cryptographic meaning).</p>

<p>To guarantee enough performance, implementations are not using a truly random number generator, but they are using a pseudo-random number generator <em>seeded</em> with a value with enough entropy. The pseudo-random number generator algorithm (PRNG) may vary across {{Glossary("user agent", "user agents")}}, but is suitable for cryptographic purposes. Implementations are required to use a seed with enough entropy, like a system-level entropy source.</p>

<p><code>getRandomValues()</code> is the only member of the <code>Crypto</code> interface which can be used from an insecure context.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedArray</var> = <var>cryptoObj</var>.getRandomValues(<var>typedArray</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>typedArray</var></code></dt>
 <dd>An integer-based {{jsxref("TypedArray")}}, that is an {{jsxref("Int8Array")}}, a {{jsxref("Uint8Array")}}, an {{jsxref("Int16Array")}}, a {{jsxref("Uint16Array")}}, an {{jsxref("Int32Array")}}, or a {{jsxref("Uint32Array")}}. All elements in the array are overwritten with random numbers.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The same array passed as <code><var>typedArray</var></code> but with its contents replaced with the newly generated random numbers. Note that <code><var>typedArray</var></code> is modified in-place, and no copy is made.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method can throw an exception under error conditions.</p>

<dl>
 <dt>{{domxref("DOMException")}} (name: {{exception("QuotaExceededError")}})</dt>
 <dd>The requested length exceeds 65,536 bytes.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>Don't use <code>getRandomValues()</code> to generate encryption keys. Instead, use the {{domxref("SubtleCrypto.generateKey", "generateKey()")}} method. There are a few reasons for this; for example, <code>getRandomValues()</code> is not guaranteed to be running in a secure context.</p>

<p>There is no minimum degree of entropy mandated by the Web Cryptography specification. User agents are instead urged to provide the best entropy they can when generating random numbers, using a well-defined, efficient pseudorandom number generator built into the user agent itself, but seeded with values taken from an external source of pseudorandom numbers, such as a platform-specific random number function, the Unix <code>/dev/urandom</code> device, or other source of random or pseudorandom data.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">/* Assuming that window.crypto.getRandomValues is available */

var array = new Uint32Array(10);
window.crypto.getRandomValues(array);

console.log("Your lucky numbers:");
for (var i = 0; i &lt; array.length; i++) {
  console.log(array[i]);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Web Crypto API', '#Crypto-method-getRandomValues')}}</td>
   <td>{{Spec2('Web Crypto API')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Crypto.getRandomValues")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API</a></li>
 <li>{{ domxref("Window.crypto") }} to get a {{domxref("Crypto")}} object.</li>
 <li>{{jsxref("Math.random")}}, a non-cryptographic source of random numbers.</li>
</ul>
